function saveUserInfo() {
  var links = document.getElementsByTagName('a')
  for (link of links) { 
    if (link.href.indexOf('contact-info') > -1) { 
      link.click();
    }
  }
  setTimeout(function() {
    var data = {};
    data.name = document.querySelector('[aria-labelledby="pv-contact-info"] h1')?.innerText;
    data.mail = document.querySelector('.pv-contact-info__contact-type.ci-email div a')?.innerText;
    data.websites = Array.from(document.querySelectorAll('.pv-contact-info__contact-type.ci-websites div a')).map( el => el.href);
    data.phone = document.querySelector('.pv-contact-info__contact-type.ci-phone ul li')?.innerText;
    data.address = document.querySelector('.pv-contact-info__contact-type.ci-address div a')?.innerText;
    data.exp = document.querySelector('#experience-section')?.innerText;
    data.about = document.querySelector('#about + div + div span')?.innerText;
    try {
      data.exp = document.querySelector('#experience-section').innerHTML.replace(/<p class="visually-hidden">.+?<\/p>/g, '').replace(/<([a-z][a-z0-9]*)[^>]*?(\/?)>/gi,'<$1$2>').replace(/<\/?ul>/g, '').replace(/\x3C!---->/g, '').replace(/<\/?span>/g, '').replace(/\n\n/g, '\n').replace(/\s+/g, ' ').replace(/<\/?header>/g, '').replace(/<svg.+?<\/svg>/g, '').replace(/<\/?li>/g, '').replace(/\/?li-icon>/g, '').replace(/<button.+?<\/button>/g, '').replace(/<div>\s+<\/div>/g, '').replace(/<img>/g, '').replace(/<a>/g, '').replace(/<\/?div>/g, '').replace(/\s+/g, ' ').replace(/<h4>/g, '').replace(/<\/h4>/g, '\n').replace(/<p>/g, '<b>').replace(/<\/p>/g, '</b><br>').replace(/>\s+/g, '>').replace(/\s+</g, '<').replace(/<\/a>/g, '<br>')
    } catch(e) {}

    try {
      data.tech = Array.from(document.querySelectorAll('.pv-skill-categories-section li p span')).map(el => el.innerText);
    } catch(e) {}

    data.linked = location.href.replace('/detail/contact-info/', '').replace(/\/overlay\/.+/, '');
    if (data.websites.length == 0) delete data.websites;
    data.twitter = document.querySelector('.pv-contact-info__contact-type.ci-twitter ul li a')?.href;
    Object.keys(data).forEach(key => data[key] === undefined && delete data[key])
    chrome.runtime.sendMessage({ data });
  },300)
  setTimeout(function() {
    document.querySelector('.artdeco-modal button').click()
  },3000)
}

function addCandidateStep1() {
  try {
    document.querySelector('.cadidates-menu-button').click()
  } catch(e) {
    alert("You need to be logged in Firmbee to add candidate");
  }
}

function addCandidateStep2() {
  document.querySelector('.new-candidate-button').click()
}

function addCandidateStep3(data) {
    var split = data.name.split(' ');
  var lname = split.pop();
  var fname = split.join(' ');
  var desc = '';

  document.querySelector('.linked-new-candidate-panel .firstname-input').value = fname;
  document.querySelector('.linked-new-candidate-panel .lastname-input').value = lname;
  if (data.mail) {
    document.querySelector('.linked-new-candidate-panel .email-input').value = data.mail;
  }
  try {
    data.phone = data.phone.match(/[+\d -]+/)[0];
    if (data.phone) {
      document.querySelector('.linked-new-candidate-panel .phone-input').value = data.phone
    }
  } catch(e) {
      }

  if (data.address) {
    desc += 'Address: ' + data.address + '\n';
  }

  if (data.websites && data.websites.length && data.websites.join('').length > 1) {
    desc += 'Web: ' + data.websites.join(', ') + '\n\n';
  }

  if (data.tech && data.tech.length && data.tech.join('').length > 1) {
    desc += 'Tech:' + data.tech.join(', ') + '\n';
  }

  if (data.exp) {
    desc += data.exp + '\n';
  }

  if (data.about) {
    desc += data.about + '\n';
  }

  if (desc) {
    document.querySelector('.linked-new-candidate-panel .description-textarea').innerHTML = desc;
  }

  if (data.twitter) {
    document.querySelector('.linked-new-candidate-panel .twitter-input').value = data.twitter;
  }
  document.querySelector('.linked-new-candidate-panel .linkedin-input').value = data.linked;

  var hiddenInput = document.querySelector('.linked-new-candidate-panel .submit-button input[type=hidden].submit-button');
  var form =  hiddenInput.form;
  hiddenInput.value = 'performAction'
  form.submit();
}

chrome.runtime.onMessage.addListener(
  function(request, sender, sendResponse) {
    chrome.tabs.query({ url: 'https://app.firmbee.com/*'}).then(tabs => {
      chrome.tabs.highlight({'tabs': tabs[0].index}, function() {});
      chrome.scripting.executeScript({
        target: { tabId: tabs[0].id },
        function: addCandidateStep1 
      })
      setTimeout(function() {
        chrome.scripting.executeScript({
          target: { tabId: tabs[0].id },
          function: addCandidateStep2
        })
      },3000)
      setTimeout(function() {
        chrome.scripting.executeScript({
          target: { tabId: tabs[0].id },
          function: addCandidateStep3,
          args: [request.data]
        })
      },6000)
    })
  }
);

chrome.action.onClicked.addListener((tab) => {
  chrome.tabs.create({ url: 'index.html' });
});

function addButtons(saveUserInfo) {
  var added = document.getElementById('firm-button');
  if (!added) {
    setTimeout(function() { 
      var added = document.getElementById('firm-button');
      if (added) return;
      var copyButton = document.querySelector('.pv-top-card-v2-ctas .pvs-profile-actions button.pvs-profile-actions__action');
      var newButton = copyButton.cloneNode();
      copyButton.parentNode.insertBefore(newButton, copyButton);
      newButton.id = "firm-button"
      newButton.innerHTML = copyButton.innerHTML;
      newButton.querySelector('span').innerHTML = "Add to Firmbee";
      newButton.style.backgroundColor = "#b6fc03";
      newButton.style.color = "black";
      newButton.onclick = function() {
        
        setTimeout(function() {
          try {
            document.querySelector('.pv-skills-section__additional-skills').click();
          } catch(e) {}

          var links = document.getElementsByTagName('a')
          for (link of links) { 
            if (link.href.indexOf('contact-info') > -1) { 
              link.click();
            }
          }
          setTimeout(function() {
            var data = {};
            data.name = document.querySelector('[aria-labelledby="pv-contact-info"] h1')?.innerText;
            data.mail = document.querySelector('.pv-contact-info__contact-type.ci-email div a')?.innerText;
            data.websites = Array.from(document.querySelectorAll('.pv-contact-info__contact-type.ci-websites div a')).map( el => el.href);
            data.phone = document.querySelector('.pv-contact-info__contact-type.ci-phone ul li')?.innerText;
            data.address = document.querySelector('.pv-contact-info__contact-type.ci-address div a')?.innerText;
            data.exp = document.querySelector('#experience-section')?.innerText;
            data.about = document.querySelector('#about + div + div span')?.innerText;
            
            try {
              data.exp = document.querySelector('#experience-section').innerHTML.replace(/<p class="visually-hidden">.+?<\/p>/g, '').replace(/<([a-z][a-z0-9]*)[^>]*?(\/?)>/gi,'<$1$2>').replace(/<\/?ul>/g, '').replace(/\x3C!---->/g, '').replace(/<\/?span>/g, '').replace(/\n\n/g, '\n').replace(/\s+/g, ' ').replace(/<\/?header>/g, '').replace(/<svg.+?<\/svg>/g, '').replace(/<\/?li>/g, '').replace(/\/?li-icon>/g, '').replace(/<button.+?<\/button>/g, '').replace(/<div>\s+<\/div>/g, '').replace(/<img>/g, '').replace(/<a>/g, '').replace(/<\/?div>/g, '').replace(/\s+/g, ' ').replace(/<h4>/g, '').replace(/<\/h4>/g, '\n').replace(/<p>/g, '<b>').replace(/<\/p>/g, '</b><br>').replace(/>\s+/g, '>').replace(/\s+</g, '<').replace(/<\/a>/g, '<br>')
            } catch(e) {}

            try {
              data.tech = Array.from(document.querySelectorAll('.pv-skill-categories-section li p span')).map(el => el.innerText);
            } catch(e) {}

            data.linked = location.href.replace('/detail/contact-info/', '').replace(/\/overlay\/.+/, '');
            if (data.websites.length == 0) delete data.websites;
            data.twitter = document.querySelector('.pv-contact-info__contact-type.ci-twitter ul li a')?.href;
            Object.keys(data).forEach(key => data[key] === undefined && delete data[key])
            chrome.runtime.sendMessage({ data });
          },1300)
          setTimeout(function() {
            document.querySelector('.artdeco-modal button').click()
          },5000)
      }, 100);
    }
  }, 1000)
  }
}

chrome.tabs.onUpdated.addListener( function (tabId, changeInfo, tab) {
  if (changeInfo.status == 'complete' && tab.active) {
    if (tab.url.indexOf('linkedin') > -1) {
      chrome.scripting.executeScript({
        target: { tabId: tab.id },
        function: addButtons
      });
    }
  }
})